import 'package:http/http.dart' as http;
import 'dart:convert';
import 'dart:async';

import 'package:movie_app/config.dart';
import 'package:movie_app/models/movie_detail_api.dart';
import 'package:movie_app/models/populars.dart';
import 'package:movie_app/models/post_rate_model.dart';
import 'package:movie_app/models/upComings.dart';

class Api {
  static Future<movieDetail> getDetail(String movieId) async {
    var apiUrl = "https://api.themoviedb.org/3/movie/" +
        movieId +
        "?api_key=" +
        apiKey +
        "&language=en-US";
    var response = await http.get(Uri.parse(apiUrl));
    var json = jsonDecode(response.body);
    return movieDetail.fromJson(json);
  }

  static Future<List<Popular>> getPopular() async {
    String apiUrl = "https://api.themoviedb.org/3/movie/popular?api_key=" +
        apiKey +
        "&language=en-US&page=1";
    var apiResult = await http.get(Uri.parse(apiUrl));
    var jsonObject = json.decode(apiResult.body);

    List<dynamic> listPopular = (jsonObject as Map<String, dynamic>)['results'];

    List<Popular> populars = [];
    for (int i = 0; i < listPopular.length; i++)
      populars.add(Popular.createPopularComing(listPopular[i]));

    return populars;
  }

  static Future<List<Coming>> getComing() async {
    String apiUrl = "https://api.themoviedb.org/3/movie/upcoming?api_key=" +
        apiKey +
        "&language=en-US&page=1";
    var apiResult = await http.get(Uri.parse(apiUrl));
    var jsonObject = json.decode(apiResult.body);

    List<dynamic> listPopular = (jsonObject as Map<String, dynamic>)['results'];

    List<Coming> populars = [];
    for (int i = 0; i < listPopular.length; i++) {
      populars.add(Coming.createComing(listPopular[i]));
    }
    print(populars);
    return populars;
  }

  static Future<PostRateResult> postReview(
      String movieId, double rating) async {
    String apiUrl = "https://api.themoviedb.org/3/movie/" +
        movieId +
        "/rating?api_key=" +
        apiKey;
    var apiResult = await http.post(Uri.parse(apiUrl), body: {
      "value": rating.toString(),
      "guest_session_id": "aa9837cfeac9f0f53b69d75fd11a001e"
    });
    var jsonObject = json.decode(apiResult.body);

    return PostRateResult.fromJson(jsonObject);
  }
}

// class ApiPopular {
//   final String vote_average;
//   final String title;
//   final String poster_path;
//   final String id;

//   ApiPopular(this.vote_average, this.title, this.poster_path, this.id);

//   factory ApiPopular.createPopular(Map<String, dynamic> json) {
//     return ApiPopular(json['vote_average'].toString(), json['title'],
//         json['poster_path'], json['id'].toString());
//   }
//   static Future<List<ApiPopular>> getPopular() async {
//     String apiUrl = "https://api.themoviedb.org/3/movie/popular?api_key=" +
//         apiKey +
//         "&language=en-US&page=1";
//     var apiResult = await http.get(Uri.parse(apiUrl));
//     var jsonObject = json.decode(apiResult.body);

//     List<dynamic> listPopular = (jsonObject as Map<String, dynamic>)['results'];

//     List<ApiPopular> populars = [];
//     for (int i = 0; i < listPopular.length; i++)
//       populars.add(ApiPopular.createPopular(listPopular[i]));

//     return populars;
//   }
// }

// class ApiUpComing {
//   final String vote_average;
//   final String title;
//   final String poster_path;
//   final String id;

//   ApiUpComing(this.vote_average, this.title, this.poster_path, this.id);

//   factory ApiUpComing.createUpComing(Map<String, dynamic> json) {
//     return ApiUpComing(json['vote_average'].toString(), json['title'],
//         json['poster_path'], json['id'].toString());
//   }
//   static Future<List<ApiUpComing>> getUpcoming() async {
//     String apiUrl = "https://api.themoviedb.org/3/movie/upcoming?api_key=" +
//         apiKey +
//         "&language=en-US&page=1";
//     var apiResult = await http.get(Uri.parse(apiUrl));
//     var jsonObject = json.decode(apiResult.body);

//     List<dynamic> listUpComing =
//         (jsonObject as Map<String, dynamic>)['results'];

//     List<ApiUpComing> upcomings = [];
//     for (int i = 0; i < listUpComing.length; i++)
//       upcomings.add(ApiUpComing.createUpComing(listUpComing[i]));
//     print(upcomings);
//     return upcomings;
//   }
// }
