import 'dart:convert';
import 'dart:async';

import 'package:flutter/material.dart';
import 'package:flutter_rating_bar/flutter_rating_bar.dart';
import 'package:movie_app/apiMovie.dart';
import 'package:movie_app/config.dart';
import 'package:http/http.dart' as http;

import '../models/movie_detail_api.dart';
import '../models/post_rate_model.dart';

class detailMovie extends StatefulWidget {
  // ScreenArguments arg;

  // detailMovie(this.arg);
  String id;
  detailMovie(this.id, {Key? key}) : super(key: key);
  @override
  _detailMovieState createState() => _detailMovieState();
}

class _detailMovieState extends State<detailMovie> {
  double rating = 0;
  movieDetail? _movieDetail;
  PostRateResult? _postRateResult;
  void postRate(double rating, String movieId) async {
    var postReview = await Api.postReview(movieId, rating);
    setState(() {
      _postRateResult = postReview;
    });
    var status_code =
        _postRateResult == null ? '' : _postRateResult!.status_code.toString();
    var message = '';
    if (status_code == "1") {
      if (rating == 10.0) {
        message = "Wow!! kamu memberikan nilai sempurna ^.^";
      } else {
        message = "Kamu memberikan " + rating.toString() + " bintang";
      }
    } else if (status_code == '12') {
      if (rating == 10.0) {
        message = "Wow!! kamu memberikan nilai update sempurna ^.^";
      } else {
        message =
            "Kamu update rating menjadi " + rating.toString() + " bintang";
      }
    } else {
      message = "Something went error";
    }
    final snackBar = SnackBar(
      backgroundColor: backgroundColor,
      content: Text(
        message,
        style: const TextStyle(
            color: textColor, fontSize: 15, fontWeight: FontWeight.w800),
      ),
      duration: Duration(seconds: 2),
    );
    ScaffoldMessenger.of(context).showSnackBar(snackBar);
  }

  void getDetailMovie(String movieId) async {
    // var response = await http.get(Uri.parse(
    //     "https://api.themoviedb.org/3/movie/" +
    //         movieId +
    //         "?api_key=" +
    //         apiKey +
    //         "&language=en-US"));
    // var json = jsonDecode(response.body);

    var response = await Api.getDetail(movieId);

    setState(() {
      _movieDetail = response;
    });
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    getDetailMovie(widget.id);
  }

  @override
  Widget build(BuildContext context) {
    // print(_postRateResult == null ? '' : _postRateResult!.status_message);
    return Scaffold(
      backgroundColor: backgroundColor,
      body: Stack(
        children: [
          ListView(
            children: [
              Container(
                margin: EdgeInsets.fromLTRB(20, 20, 20, 10),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    GestureDetector(
                      onTap: () {
                        Navigator.pop(
                          context,
                        );
                      },
                      child: const Icon(
                        Icons.arrow_back_ios_new,
                        color: textColor,
                      ),
                    ),
                    const Text(
                      "Detail Movies",
                      style: TextStyle(
                          color: textColor,
                          fontSize: 20,
                          fontWeight: FontWeight.w800),
                    ),
                    const Icon(
                      Icons.bookmark_border_outlined,
                      color: textColor,
                    ),
                  ],
                ),
              ),
              Center(
                child: Container(
                  height: 500,
                  width: 300,
                  decoration:
                      BoxDecoration(borderRadius: BorderRadius.circular(40)),
                  margin: EdgeInsets.fromLTRB(30, 30, 30, 10),
                  child: Material(
                    elevation: 10,
                    borderRadius: BorderRadius.circular(40),
                    color: Colors.transparent,
                    child: ClipRRect(
                      borderRadius: BorderRadius.circular(40),
                      child: _movieDetail == null
                          ? const SizedBox(
                              width: 10,
                            )
                          : Image(
                              image: NetworkImage(
                                  "https://image.tmdb.org/t/p/w500" +
                                      _movieDetail!.poster_path),
                              fit: BoxFit.cover,
                              height: 500,
                              width: 300,
                            ),
                    ),
                  ),
                ),
              ),
              Column(
                children: [
                  Container(
                    margin: EdgeInsets.only(top: 10),
                    width: 300,
                    child: Text(
                      _movieDetail == null ? '' : _movieDetail!.title,
                      textAlign: TextAlign.start,
                      style: const TextStyle(
                          fontSize: 25,
                          fontWeight: FontWeight.w700,
                          color: textColor),
                    ),
                  ),
                  Container(
                    margin: EdgeInsets.fromLTRB(50, 30, 30, 10),
                    child: Row(
                      children: [
                        const Text(
                          'Director: Dio Maulana | ',
                          style: TextStyle(
                              fontSize: 15,
                              color: textColor,
                              fontWeight: FontWeight.w400),
                        ),
                        Text(
                          _movieDetail == null
                              ? ''
                              : _movieDetail!.vote_average.toString(),
                          style: const TextStyle(
                              fontSize: 15,
                              color: textColor,
                              fontWeight: FontWeight.w400),
                        ),
                        const Icon(
                          Icons.star,
                          color: Colors.yellow,
                        )
                      ],
                    ),
                  ),
                  Container(
                    margin: EdgeInsets.fromLTRB(50, 0, 30, 10),
                    height: 50,
                    child: _movieDetail == null
                        ? const SizedBox(
                            width: 1,
                          )
                        : ListView(
                            scrollDirection: Axis.horizontal,
                            children: _movieDetail!.genre
                                .map(
                                  (e) => Container(
                                    margin: EdgeInsets.only(left: 5),
                                    child: RaisedButton(
                                      shape: RoundedRectangleBorder(
                                          borderRadius:
                                              BorderRadius.circular(25)),
                                      color: Color(0xFF05104f),
                                      child: Text(
                                        e,
                                        style: TextStyle(color: textColor),
                                      ),
                                      onPressed: () {},
                                    ),
                                  ),
                                )
                                .toList(),
                          ),
                  ),
                  Container(
                    margin: EdgeInsets.only(top: 10),
                    width: 300,
                    child: const Text(
                      "Synopsis",
                      textAlign: TextAlign.start,
                      style: TextStyle(
                          fontSize: 20,
                          fontWeight: FontWeight.w500,
                          color: textColor),
                    ),
                  ),
                  Container(
                      margin: EdgeInsets.fromLTRB(50, 30, 30, 10),
                      child: Text(
                        _movieDetail == null ? '' : _movieDetail!.overview,
                        textAlign: TextAlign.start,
                        style: const TextStyle(
                            color: textColor,
                            fontSize: 15,
                            fontWeight: FontWeight.w400),
                      )),
                  const SizedBox(
                    height: 35,
                  )
                ],
              )
            ],
          ),
          Align(
              alignment: Alignment.bottomCenter,
              child: RaisedButton(
                  child: Text('Rate This Movie'),
                  color: Colors.yellow,
                  shape: RoundedRectangleBorder(
                      borderRadius: BorderRadius.circular(25)),
                  onPressed: () {
                    showModalBottomSheet<void>(
                      context: context,
                      builder: (BuildContext context) {
                        return Container(
                          height: 200,
                          color: Color(0xFF05104f),
                          child: Center(
                            child: Column(
                              mainAxisAlignment: MainAxisAlignment.center,
                              mainAxisSize: MainAxisSize.min,
                              children: <Widget>[
                                const Text(
                                  "Rate this movie ",
                                  style: TextStyle(color: textColor),
                                ),
                                const SizedBox(
                                  height: 10,
                                ),
                                RatingBar.builder(
                                  initialRating: 1,
                                  minRating: 1,
                                  itemSize: 46,
                                  allowHalfRating: true,
                                  itemCount: 10,
                                  // itemPadding:
                                  //     EdgeInsets.symmetric(horizontal: 5),
                                  itemBuilder: (context, _) =>
                                      Icon(Icons.star, color: Colors.yellow),
                                  updateOnDrag: true,
                                  onRatingUpdate: (rating) => setState(() {
                                    this.rating = rating;
                                  }),
                                ),
                                RaisedButton(
                                    child: Text("Submit"),
                                    shape: RoundedRectangleBorder(
                                        borderRadius:
                                            BorderRadius.circular(25)),
                                    color: Colors.yellow,
                                    onPressed: () {
                                      postRate(rating, widget.id);
                                      Navigator.pop(context);
                                    })
                              ],
                            ),
                          ),
                        );
                      },
                    );
                  }))
        ],
      ),
    );
  }
}
